import App from './app';
import Config from './config';
export default abstract class BaseModule {
    abstract get controllers(): string;
    abstract get middlewares(): string;
    abstract get translation(): string;
    abstract get views(): string;
    abstract get public(): string;
    abstract get entities(): string;
    abstract get migrations(): string;
    abstract get templating(): string;
    mount(config: Config): void;
    /**
     * This method is called when the connection to the database is established.
     */
    onDatabaseConnected(): void;
    /**
     * This method is called when the Lynx app is configured and ready to be executed.
     */
    onAppReady(app: App): Promise<void>;
}
