/**
 * Base class for any function class.
 * Each function class will be automatically instantiated once.
 */
export default abstract class BaseFunction {
    /**
     * Utility function to safe obtain an argument.
     * @param args the arguments array
     * @param index the index of the argument to obtain
     */
    safeGet(args: any[], index: number): any;
    /**
     * This method will be executed when the corresponding function needs to be executed.
     * @param args are the arguments passed to the function when executed.
     */
    abstract execute(...args: any[]): any;
}
