export default interface UFS {
    unlink(path: string, cb: (err: Error) => void): void;
    stat(path: string): Promise<Stat>;
    getToCache(path: string, cachePath: string): Promise<string>;
    uploadFile(uploadMedia: any): Promise<any>;
    uploadFileFromCache(path: string, cachePath: string): Promise<void>;
    uploadTempFile(path: string): Promise<{
        fileName: string;
        path: string;
    }>;
}
export interface Stat {
    size: number;
}
export declare class LocalUFS implements UFS {
    unlink(path: string, cb: (err: Error) => void): void;
    stat(path: string): Promise<Stat>;
    getToCache(path: string, _: string): Promise<string>;
    uploadFile(uploadMedia: any): Promise<any>;
    uploadFileFromCache(path: string, cachePath: string): Promise<void>;
    uploadTempFile(path: string): Promise<{
        fileName: string;
        path: string;
    }>;
}
